; 
    include \masm32\include\masm32rt.inc
    .686
    include counter2.asm

    PRIORITY_CLASS equ HIGH_PRIORITY_CLASS
    ;REALTIME_PRIORITY_CLASS

    TEST_SETS     EQU 5
    REPEAT_COUNT  EQU 20
    SAMPLE_COUNT  EQU 16

; 

    ; -------------------------------------------------------
    ; This is an assembly-time random number generator based
    ; on code by George Marsaglia:
    ;   #define znew  ((z=36969*(z&65535)+(z>>16))<<16)
    ;   #define wnew  ((w=18000*(w&65535)+(w>>16))&65535)
    ;   #define MWC   (znew+wnew)
    ; -------------------------------------------------------

    @seed MACRO
      @znew_seed@ = 362436069
      @wnew_seed@ = 521288629
    ENDM

    @seed

    @rnd MACRO base:REQ
      LOCAL znew, wnew

      @znew_seed@ = 36969 * (@znew_seed@ AND 65535) + (@znew_seed@ SHR 16)
      znew = @znew_seed@ SHL 16

      @wnew_seed@ = 18000 * (@wnew_seed@ AND 65535) + (@wnew_seed@ SHR 16)
      wnew = @wnew_seed@ AND 65535

      EXITM <(znew + wnew) MOD base>
    ENDM

; 

    ; herge.

    abs0 MACRO
        push eax
        and eax, 80000000h
        cmp eax, 80000000h
        pop eax
        jnz @f
        neg eax
      @@:
    ENDM

    ; evlncrn8, reply #1.

    abs1 MACRO
        test eax, 80000000h
        jz @F
        neg eax
      @@:
    ENDM

    ; jimg, reply #2.

    abs2 MACRO
        or eax, eax
        jns @F
        neg eax
      @@:
    ENDM

    ; Rockoon, reply #5, modified to leave result in eax for function test.

    abs3 MACRO
        mov ecx, eax
        sar eax, 31
        add ecx, eax
        xor ecx, eax
        mov eax, ecx
    ENDM

    ; drizz, reply #7.

    abs4 MACRO
        cdq
        xor eax,edx
        sub eax,edx
    ENDM

    ; jj2007, reply #22,

    abs5 MACRO
      .if eax>=80000000h
        neg eax
      .endif
    ENDM

    ; hutch, reply #19.

    abs6 MACRO
        mov ecx, eax
        neg ecx
        test eax, eax
        cmovs eax, ecx
    ENDM

    ; hutch, reply #19.

    abs7 MACRO
        add eax, 0
        jns @F
        neg eax
      @@:
    ENDM

    ; NightWare, reply #24, modified to receive and return in eax.

    abs8 MACRO
        test eax, eax
        jns @F
        neg eax
      @@:
    ENDM

    ; NightWare, reply #24, modified to receive and return in eax.

    abs9 MACRO
        bt eax,31
        jnc @F
        neg eax
      @@:
    ENDM

    ; jimg2
    abs10 MACRO
        mov edx,eax
        neg edx
        cmovns eax,edx
    ENDM

; 
    .data
    .code
; 
start:
; 

    crtabs MACRO
      invoke crt_abs, eax
    ENDM

    ; ---------------
    ; Function tests.
    ; ---------------

    FOR mac,<abs0,abs1,abs2,abs3,abs4,abs5,abs6,abs7,abs8,abs9,abs10,crtabs>
      print "&mac",9
      mov eax, 0
      mac
      print ustr$(eax)," "
      mov eax, 1
      mac
      print ustr$(eax)," "
      mov eax, 2147483647
      mac
      print ustr$(eax)," "
      mov eax, -1
      mac
      print ustr$(eax)," "
      mov eax, -2147483648
      mac
      print ustr$(eax),13,10
    ENDM
    print chr$(13,10)

    invoke Sleep, 4000

    REPEAT TEST_SETS

      xor ebx, ebx
      REPEAT SAMPLE_COUNT
        @seed
        ctr_begin 1000, PRIORITY_CLASS
          REPEAT REPEAT_COUNT
            mov eax, @rnd(0ffffffffh)
            abs0
          ENDM
        ctr_end
        add ebx, eax
      ENDM
      mov ecx, SAMPLE_COUNT
      mov eax, ebx
      div ecx
      print ustr$(eax), " cycles, abs0 (herge)",13,10
      xor ebx, ebx
      REPEAT SAMPLE_COUNT
        @seed
        ctr_begin 1000, PRIORITY_CLASS
          REPEAT REPEAT_COUNT
            mov eax, @rnd(0ffffffffh)
            abs1
          ENDM
        ctr_end
        add ebx, eax
      ENDM
      mov ecx, SAMPLE_COUNT
      mov eax, ebx
      div ecx
      print ustr$(eax), " cycles, abs1 (evlncrn8)",13,10
      xor ebx, ebx
      REPEAT SAMPLE_COUNT
        @seed
        ctr_begin 1000, PRIORITY_CLASS
          REPEAT REPEAT_COUNT
            mov eax, @rnd(0ffffffffh)
            abs2
          ENDM
        ctr_end
        add ebx, eax
      ENDM
      mov ecx, SAMPLE_COUNT
      mov eax, ebx
      div ecx
      print ustr$(eax), " cycles, abs2 (jimg1)",13,10
      xor ebx, ebx
      REPEAT SAMPLE_COUNT
        @seed
        ctr_begin 1000, PRIORITY_CLASS
          REPEAT REPEAT_COUNT
            mov eax, @rnd(0ffffffffh)
            abs3
          ENDM
        ctr_end
        add ebx, eax
      ENDM
      mov ecx, SAMPLE_COUNT
      mov eax, ebx
      div ecx
      print ustr$(eax), " cycles, abs3 (Rockoon)",13,10
      xor ebx, ebx
      REPEAT SAMPLE_COUNT
        @seed
        ctr_begin 1000, PRIORITY_CLASS
          REPEAT REPEAT_COUNT
            mov eax, @rnd(0ffffffffh)
            abs4
          ENDM
        ctr_end
        add ebx, eax
      ENDM
      mov ecx, SAMPLE_COUNT
      mov eax, ebx
      div ecx
      print ustr$(eax), " cycles, abs4 (drizz)",13,10
      xor ebx, ebx
      REPEAT SAMPLE_COUNT
        @seed
        ctr_begin 1000, PRIORITY_CLASS
          REPEAT REPEAT_COUNT
            mov eax, @rnd(0ffffffffh)
            abs5
          ENDM
        ctr_end
        add ebx, eax
      ENDM
      mov ecx, SAMPLE_COUNT
      mov eax, ebx
      div ecx
      print ustr$(eax), " cycles, abs5 (jj2007)",13,10
      xor ebx, ebx
      REPEAT SAMPLE_COUNT
        @seed
        ctr_begin 1000, PRIORITY_CLASS
          REPEAT REPEAT_COUNT
            mov eax, @rnd(0ffffffffh)
            abs6
          ENDM
        ctr_end
        add ebx, eax
      ENDM
      mov ecx, SAMPLE_COUNT
      mov eax, ebx
      div ecx
      print ustr$(eax), " cycles, abs6 (hutch1)",13,10
      xor ebx, ebx
      REPEAT SAMPLE_COUNT
        @seed
        ctr_begin 1000, PRIORITY_CLASS
          REPEAT REPEAT_COUNT
            mov eax, @rnd(0ffffffffh)
            abs7
          ENDM
        ctr_end
        add ebx, eax
      ENDM
      mov ecx, SAMPLE_COUNT
      mov eax, ebx
      div ecx
      print ustr$(eax), " cycles, abs7 (hutch2)",13,10
      xor ebx, ebx
      REPEAT SAMPLE_COUNT
        @seed
        ctr_begin 1000, PRIORITY_CLASS
          REPEAT REPEAT_COUNT
            mov eax, @rnd(0ffffffffh)
            abs8
          ENDM
        ctr_end
        add ebx, eax
      ENDM
      mov ecx, SAMPLE_COUNT
      mov eax, ebx
      div ecx
      print ustr$(eax), " cycles, abs8 (NightWare1)",13,10
      xor ebx, ebx
      REPEAT SAMPLE_COUNT
        @seed
        ctr_begin 1000, PRIORITY_CLASS
          REPEAT REPEAT_COUNT
            mov eax, @rnd(0ffffffffh)
            abs9
          ENDM
        ctr_end
        add ebx, eax
      ENDM
      mov ecx, SAMPLE_COUNT
      mov eax, ebx
      div ecx
      print ustr$(eax), " cycles, abs9 (NightWare2)",13,10
      xor ebx, ebx
      REPEAT SAMPLE_COUNT
        @seed
        ctr_begin 1000, PRIORITY_CLASS
          REPEAT REPEAT_COUNT
            mov eax, @rnd(0ffffffffh)
            abs10
          ENDM
        ctr_end
        add ebx, eax
      ENDM
      mov ecx, SAMPLE_COUNT
      mov eax, ebx
      div ecx
      print ustr$(eax), " cycles, abs10 (jimg2)",13,10
      xor ebx, ebx
      REPEAT SAMPLE_COUNT
        @seed
        ctr_begin 1000, PRIORITY_CLASS
          REPEAT REPEAT_COUNT
            mov eax, @rnd(0ffffffffh)
            invoke crt_abs, eax
          ENDM
        ctr_end
        add ebx, eax
      ENDM
      mov ecx, SAMPLE_COUNT
      mov eax, ebx
      div ecx
      print ustr$(eax), " cycles, abs10 (crt_abs)",13,10,13,10

    ENDM

    inkey "Press any key to exit..."
    exit
; 
end start
